        .section ".resetvec", "a"
		 .word   _start	; Startadresse nach einem Reset
	
	
	.text
	        .global _start
	        .type _start, @function
_start:

	;; Variablen die der Linker bereitstellt:
	;; __stack :	Position des Stack

	;; Das sind die Variablen die mit 0 initialisiert werden
	;; __bssstart :	Start der Variablen im Ram des R8C
	;; __bssend   :	Ende der Variablen im Ram
	;; __bsssize :	Groesse des Rambereichs fuer Variablen

	;; __romdatastart       Variablen im Rom
	;; __etext       0xe083 Variablen im Rom
	;; __romdatacopysize :	Anzahl der Byte die aus dem Flash in Ram kopiert werden

	;; Das sind die Variablen die mit einem Wert initialisiert werden
	;; __datastart   0x0500
	;; __dataend	 0x0502

	;; Wir muessen von __romdatastart nach __datastart genau __romdatacopysize
	;; Bytes kopieren
	
	
	;; Protect-Bits setzen um pm1 Register freizuschalten
	        mov.b   #0x03,r0l
		mov.b	r0l,0x000a

	;; PM13 setzen damit wir wirklich 20k Ram benutzen koennen
		mov.b	#0x08,r0l
		mov.b	r0l,0x0005

	;; Und jetzt koennen wir den Stack an das Ende des Rams setzen
	        ldc     #__stack, sp ;  set user stack pointer
	
	;; Und wo ist der Interruptstack????
	
	;; Loeschen der Variablen
	        mov.b #%hi8(__bssstart),r0l
	        mov.w #%lo16(__bssstart),a1
		mov.w   #__bsssize, R3
	        sstr.b
	
	;; Kopieren von Variablen aus dem Rom ins Ram
	        mov.b #%hi8(__romdatastart),r1h ; hoeherwerte 8bit.
	        mov.w #%lo16(__romdatastart),a0 ; Niederwertigen 16bit
	
	        mov.w   #__datastart,a1
	        mov.w   #__romdatacopysize , r3
	        smovf.b
		
	
	        jsr.w   _main	;  go to main in main.c
                
loop:				; Fuer den Fall das main zurueckgekehrt
	        jmp.w loop



	