#ifdef MAIN
#define EXT
#else
#define EXT extern
#endif

#define RoundTimer 10000         /* Zeit in us fuer einen Taskumlauf */
#define STACK_SIZE 0x200         /* Stackgroesse einer Task          */
#define MAX_TASKS  2             /* maximale Anzahl der Tasks        */

#define TASK_STOP  0             /* Moegliche Zustaende einer Task   */
#define TASK_START 1
#define TASK_RUN   2

void tasker_init(void);
void tasker_main(void);
extern void  tasker_switch(void);
void tasker_func(void * function, unsigned char Prioritaet, unsigned char TaskNum);
void tasker_start(void);
void tasker_stop(void);
void tasker_suspend(void);
void Semphore_wait(int SemaValue);
void Semaphore_free(int SemaValue);
void tasker_delaycount(void);
void delay(unsigned short timevalue);

/* Hier stehen die Register und Daten einer Task                 */
/* Der Scheduler verlaesst sich auf Groesse und Position der     */
/* Variablen weil er ueber FB auf die Variablen zugreift!        */
typedef volatile struct 
{
  volatile unsigned short RegR0;     /*  0 Registerspeicher      */
  volatile unsigned short RegR1;     /*  2                       */
  volatile unsigned short RegR2;     /*  4                       */
  volatile unsigned short RegR3;     /*  6                       */
  volatile unsigned short RegA0;     /*  8                       */
  volatile unsigned short RegA1;     /* 10                       */
  volatile unsigned short RegFB;     /* 12 FrameBase-Register    */
  volatile unsigned short RegSB;     /* 14 StaticBase-Register   */
  volatile unsigned short RegSP;     /* 16 Stack                 */ 
  volatile unsigned short RegFLG;    /* 18 Flags +Adress High    */
  volatile void *next;               /* 20 Naechste Task         */
  volatile void *Adresse;            /* 22 Adresse die laeuft    */
  volatile unsigned short TimeValue; /* 24 Laufzeit Timer        */
  volatile unsigned short Prioritaet; /* 26                      */
  volatile unsigned short RunFlag;    /* 28  Zustand der Task    */
  volatile unsigned short DelayCount; /* 30 Wartezeit Delay      */
  volatile unsigned char stack[STACK_SIZE]; /* 32 STack der Task */
} TaskMemory;

/* Liste mit den Daten der Tasks, kann gross werden! */
EXT TaskMemory TaskRam[MAX_TASKS];

/* Pointer auf den Datensatz der gerade aktiven Task */
EXT void *TaskPointer;

/* Maximale Anzahl der dem System bekannten Semaphoren */
#define MAX_SEMA 3

/* Das sind die dem System bekannten Semphoren */
#define SEMA_PORT 0         /* Zugriffe auf Ports          */
#define SEMA_LCD  1         /* Nutzung von printf aufs LCD */
#define SEMA_USER 2         /* Erstmal ungenutzt           */

typedef volatile struct 
{
  volatile signed short counter;
} Semaphor;


