#include "sfr62.h"    // special funktion register
#include "ticker.h"
#include "tools.h"
#include "taskerC.h"
#include "MultiTasker.h"


unsigned short TimeCounter;


/*******************************************************************/
/* Initialisiert den Ticker-Interrupt (Timer A1                    */
/*******************************************************************/
void init_ticker(void)
{

  ta1mr = 0x80; /* Timer mode mit 16Mhz / 32 = 500khz Takt */
  ta1ud = 0;    /* Wir wollen runterzaehlen */

  ta1s = 0;                 /* Timer anhalten                         */
  ir_ta1ic = 0;             /* Ueberlaufflag im IRQ-Register loeschen */
  ta1  = 5000;              /* Zaehlvariable setzen                   */
  ta1s = 1;                 /* Timer starten                          */

  ta1ic = 0x02;             /* IRQ auf Level2, (niedrig+1) freigeben    */
}

/*******************************************************************/
/* Der Interrupt wird 100mal pro Sekunde aufgerufen                */
/*******************************************************************/
void tickerint(void)
{ 

  tasker_delaycount();

  if (tickervalue>0) tickervalue--;

  TimeCounter++;


}

/* Loescht Zaehler */
void ticker_timercounterclear(void)
{
  TimeCounter=0;
}

/* Abfrage der verflossenen Zeit in 10ms Aufloesung fuer Zeitmessung */
/* bei der Programmentwicklung Funktioniert fuer maximal 10.9Minuten */
/* Laufzeit!                                                         */
unsigned short ticker_timercounterask(void)
{
  return(TimeCounter);
}

