/***********************************************************************/
/* Libary mit allgemeinen Tools fuer den M16C die man immer so braucht */
/***********************************************************************/

#include <stdarg.h>
#include "sfr62.h"    // special funktion register

#include "tools.h"

/* Wir gehen im folgenden davon aus das am MainClock ein Quarz von 16Mhz */
/* haengt. Nach einem Reset laeuft die CPU mit 16Mhz/8=2Mhz              */

void maxspeed(void)
{
  /* Bis jetzt laeuft der Prozessor noch mit internem 128kHz durch 8 Takt */
  prc0 = 1;  /* Clock Register freigeben */

  cm15 = 1;  /* Hohe Treiberleistung */

  cm16 = 0;  /* CPU Teiler abschalten */
  cm17 = 0;

  cm06 = 0;  /* Vorteiler einschalten */
     
  prc0 = 0;   /* Register schuetzen */

  /* Und jetzt laeuft alles mit 16MHz */

  //  prc0 = 1;   
  // pm13 = 1;   /* Das koennte notwendig sein um 20k Ram zu nutzen */   
  //prc0 = 1;
}

unsigned short strlen(char *str)
{
  char *start = str;

  while (*str) str++;

  return (str - start);
}


int strcmp(char *s1, char *s2)
{
  while (*s1 == *s2++)
    if (*s1++ == 0) return (0);

  return (*(const unsigned char *)s1 - *(const unsigned char *)(s2 - 1));
}

char *strcpy(char *to, char *from)
{
  char *save = to;

  for (; (*to = *from) != 0; ++from, ++to);
  return(save);
}

void *memcpy(void *dest, const void *src, unsigned short count)
{

  char* dst8 = (char*)dest;
  char* src8 = (char*)src;

  --src8;
  --dst8;
        
  while (count--) { *++dst8 = *++src8;  }

  return dest;


}

/*********************************************************************/
/* Wir benutzen den Timer A0 als Zeitgeber weil das eleganter ist    */
/* als aktives warten und vor allem auch noch funktioniert wenn im   */
/* irq Zeit verloren geht!                                           */
/*********************************************************************/
void init_delay_timer(void)
{
     
  ta0mr = 0x80; /* Timer mode mit 16Mhz / 32 = 500khz Takt */
  ta0ud = 0;    /* Wir wollen runterzaehlen */

}


/*********************************************************************/
/* Startet den Timer A0                                              */
/* Es wird ein Wert in us erwartet.                                  */
/* Kleinstmoeglich Wartezeit ist 2us.                                */
/* Groestmoegliche Wartezeit ist 65535us, also 65ms                  */
/*********************************************************************/
void start_delay_timer(unsigned short countvalue)
{

  ta0s = 0;                 /* Timer anhalten                         */
  ir_ta0ic = 0;             /* Ueberlaufflag im IRQ-Register loeschen */
  ta0  = countvalue>>1;     /* Zaehlvariable setzen                   */
  ta0s = 1;                 /* Timer starten                          */
}

/*********************************************************************/
/* Liefert TRUE wenn der Timer abgelaufen ist                        */
/*********************************************************************/
int ask_delay_timer(void)
{
  if ( ir_ta0ic ) return (TRUE);
  return(FALSE);
}

/**********************************************************************/
/* Wartet die uebergebene Wartezeit in us und kehrt dann erst zurueck */
/**********************************************************************/
void udelay(unsigned short wartezeit)
{
  start_delay_timer(wartezeit);
   while (!ir_ta0ic); /* Warten bis Timer auf 0 */
}

/**********************************************************************/
/* Wartet die uebergebene Wartezeit in ms und kehrt dann erst zurueck */
/**********************************************************************/
/*
void delay(unsigned short wartezeit)
{ unsigned short i;

 for(i=0;i<wartezeit;i++) udelay(1000);
}
*/
